<html>
<!--

  Arkanon <arkanon@lsd.org.br>
  2019/11/28 (Thu) 21:50:44 -03
  2018/10/21 (Sun) 16:52:03 -03 - v0.4
  2018/10/21 (Sun) 03:03:29 -03
  2018/10/20 (Sat) 21:47:13 -03
  2018/10/19 (Fri) 21:09:26 -03
  2013/07/14 (Sun) 16:22:15 -03 - v0.3
  2013/05/03 (Fri) 04:09:43 -03 - v0.2
  2013/04/19 (Fri) 02:08:11 -03 - v0.1

  <http://news.ycombinator.com/item?id=12168866>
  <http://valera-rozuvan.github.io/FractalViewer>

-->
<head>
  <meta charset="utf-8">
  <title>Mandelkeks</title>
  <!--script src="http://unpkg.com/mathjs/dist/math.js"></script-->
  <script>

    var I, O, fW;

     I = getParameterByName('I'    ) || 10000;
     O = getParameterByName('O',',') || [-0.7450206180950283,0.12440120606266036];
    fW = getParameterByName('fW'   ) || 0.00001267829811506426;

    if (
         ! getParameterByName('I'    ) ||
         ! getParameterByName('O',',') ||
         ! getParameterByName('fW'   )
       )
       location = '?I='+I + '&O='+O + '&fW='+fW;

    var body, marginTop, marginRight, marginBottom, marginLeft;
    var canvas, canvas_id, context, dataset, row, col, N, M, m, Cr, Ci, ins;
    var gradient, mandelcor, sqmodlim, Z0r, Z0i, W, H, I, S, O, L, R;

    function rq (x) { return Math.sqrt (x) }
    function sen(x) { return Math.sin  (x) }
    function cos(x) { return Math.cos  (x) }
    function tg (x) { return sen(x)/cos(x) }
    function ln (x) { return Math.log  (x) }
    function abs(x) { return Math.abs  (x) }

    var fi = (rq(5)+1)/2;
    var pi = 4*Math.atan(1);

    window.onload = function()
    {

      mandelcor = [0, 0, 0];
       sqmodlim = 4;
            Z0r = 0;
            Z0i = 0;

      canvas_id    = 'plano';

      body         = document.getElementsByTagName('body')[0];
      marginTop    = computed('margin-top'   );
      marginRight  = computed('margin-right' );
      marginBottom = computed('margin-bottom');
      marginLeft   = computed('margin-left'  );

   // I = 10000;

   // O = [ 0 , 0 ];
   // O = [ -0.7450206180950283 , 0.12440120606266036 ];

   // S = 1;
   // W = 500;
   // H = 500;
   // L = [ -2.010 , -2.01000 ]; R = [  2.010 , 2.01000 ];
   // L = [ -1.944 , -0.00200 ]; R = [ -1.939 , 0.00200 ];
   // L = [ -1.944 , -0.00124 ]; R = [ -1.939 , 0.00124 ];

      W = window.innerWidth  - ( marginLeft + marginRight  );
      H = window.innerHeight - ( marginTop  + marginBottom );
   // S = 2 * Math.sqrt(sqmodlim) / (H>W?W:H);
   // L = [ O[0] - S*W/2 , O[1] - S*H/2 ];
   // R = [ O[0] + S*W/2 , O[1] + S*H/2 ];

   // if ( H === undefined )
   // {
   //   S = (R[0]-L[0])/W;
   //   H = W*(R[1]-L[1])/(R[0]-L[0]);
   // }
   // else
   // {
   //   S = (R[1]-L[1])/H;
   //   W = H*(R[1]-L[1])/(R[0]-L[0]);
   // }

 // var fW = 0.00001267829811506426;
    var fH = fW*H/W;
         L = [ O[0] - fW/2 , O[1] - fH/2 ];
         R = [ O[0] + fW/2 , O[1] + fH/2 ];
         S = (R[0]-L[0])/W;

      canvas        = document.getElementById(canvas_id);
      canvas.width  = W;
      canvas.height = H;
      context       =  canvas.getContext('2d');
      dataset       = context.getImageData(0, 0, W, H);

      // <http://colorzilla.com/gradient-editor>
   // gradient = [
   //              [ [ 255, 255, 255 ],   0 ],
   //              [ [   1,  15, 170 ],  20 ],
   //              [ [  26, 193,  23 ],  40 ],
   //              [ [ 240, 244,   2 ],  60 ],
   //              [ [ 117,  34,   1 ],  80 ],
   //              [ [   0,   0,   0 ], 100 ],
   //            ];

      gradient = [
                   [ [ 127, 127, 127 ],    0 ],
                   [ [   0,  64,   0 ],   20 ],
                   [ [   0,   0,   0 ],   50 ],
                   [ [ 153,   0,   0 ], 1000 ],
                   [ [ 239, 182,  47 ], 3000 ],
                   [ [  39,  82,  47 ], 5000 ],
                   [ [   0,   0, 127 ], 8500 ],
                 ];

      row = 0;
      Ci  = R[1];

      delay = new time(0,0,0,0);
      delay.StartTiming();
      mainloop();

    }



    function mainloop()
    {
      var cor;
      col = 0;
      for (Cr=L[0]; Cr<=R[0]; Cr+=S)
      {
        ins = inSet1(Cr, Ci, I, sqmodlim);
          M = Math.sqrt(ins[1]);
          m = Math.sqrt(ins[2]);
          N =           ins[3];

        // <http://stackoverflow.com/a/25816111>
        // Based on <http://jsfiddle.net/vksn3yLL> from <http://stackoverflow.com/a/30144587>
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1328>     interactive
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1316> non-interactive
        var slider        = N;
        var colorRange = [ gradient.length-2, gradient.length-1 ];
        for ( var index in gradient ) if ( slider <= gradient[index][1] ) { colorRange = [ index-1, index ]; break }

        // get the two closest colors
        var firstcolor    = gradient[colorRange[0]][0];
        var secondcolor   = gradient[colorRange[1]][0];

        // calculate ratio between the two closest colors
        var firstcolor_x  = gradient[colorRange[0]][1]/100;
        var secondcolor_x = gradient[colorRange[1]][1]/100 - firstcolor_x;
        var slider_x      = slider/100                     - firstcolor_x;
        var ratio         = slider_x/secondcolor_x;

            cor           = ( ins[0] || N==1 ) ? mandelcor : pickHex( secondcolor, firstcolor, ratio );

        plotpix(row, col, cor);
        col++;
      }
      Ci -= S;
      row++;
      context.putImageData(dataset, 0, 0);
      if ( Ci>=L[1] ) setZeroTimeout(mainloop); else console.log("Renderizado em "+delay.EndTiming()+" segundos");
    }



    function  inSet1(Cr, Ci, I, sqmodlim)
    {
      var tmp, znr, zni, znm2, n;
      znr = Z0r;
      zni = Z0i;
      for (n=1; n<=I; n++)
      {
        // <http://maxima.cesga.es>
        // z²+c
        tmp  = 2*znr*zni + Ci;
        znr  = znr*znr - zni*zni + Cr;
        zni  = tmp;
        znm2 = znr*znr + zni*zni;
        cm2  = Cr*Cr + Ci*Ci;
        if (znm2 >= sqmodlim) return [false, znm2, cm2, n];
      }
      return [true, znm2, cm2];
    }



    function  inSet2(Cr, Ci, I, sqmodlim)
    {
      var tmp, znr, zni, znm2, n;
      C  = math.complex(  Cr ,  Ci );
      Zn = math.complex( Z0r , Z0i );
      for (n=1; n<=I; n++)
      {
        Zn = math.add(math.pow(Zn,2), C);

     // Zm = math.norm(Zn);
     // Cm = math.norm(C );
     // if (Zm >= 2) return [false, Zm, Cm, n];

        Zm2 = math.pow(math.re(Zn),2) + math.pow(math.im(Zn),2);
        Cm2 = math.pow(math.re(C ),2) + math.pow(math.im(C ),2);
        if (Zm2 >= sqmodlim) return [false, Zm2, Cm2, n];

      }
   // return [true, Zm, Cm];
      return [true, Zm2, Cm2];
    }



    function plotpix(row, col, cor)
    {
      var i = ( row * W + col )*4;
      dataset.data[i+0] = cor[0];
      dataset.data[i+1] = cor[1];
      dataset.data[i+2] = cor[2];
      dataset.data[i+3] = 255;
    }



    function pickHex(color1, color2, weight)
    {
      var p   = weight;
      var w   = 2*p - 1;
      var w1  = (w+1)/2;
      var w2  = 1 - w1;
      var rgb = [
                  Math.round( w1*color1[0] + w2*color2[0] ),
                  Math.round( w1*color1[1] + w2*color2[1] ),
                  Math.round( w1*color1[2] + w2*color2[2] ),
                ];
      return rgb;
    }



    function computed(prop)
    {
      return parseFloat(window.getComputedStyle(body).getPropertyValue(prop));
    }



    function time(this_current_time, this_start_time, this_end_time, this_time_difference)
    // Elapsed Time Calculator
    // by David Tam <http://www.ComputationalNeuralSystems.com/>
    //
    // Usage:
    //    var delay = new aux.timestamp(0,0,0,0);
    //    delay.StartTiming();
    // // { javascript code }
    //    esc(delay.EndTiming());
    {
      this.this_current_time    = this_current_time;
      this.this_start_time      = this_start_time;
      this.this_end_time        = this_end_time;
      this.this_time_difference = this_time_difference;

      this.GetCurrentTime = function()
      // get current time from date timestamp
      {
        var my_current_timestamp;
            my_current_timestamp = new Date();						// stamp current date & time
        return my_current_timestamp.getTime();
      }

      this.StartTiming = function()
      // stamp current time as start time and reset display textbox
      {
        this.this_start_time = this.GetCurrentTime();					// stamp current time
      }

      this.EndTiming = function()
      // stamp current time as stop time, compute elapsed time difference and display in textbox
      {
        this.this_end_time = this.GetCurrentTime();					// stamp   current time
        this.this_time_difference = (this.this_end_time - this.this_start_time) / 1000;	// compute elapsed time
        return this.this_time_difference;						// return  elapsed time
      }

    }



    function getParameterByName(name, splitstr, type)
    // <http://stackoverflow.com/a/901144>
    {
      name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
      var regexS  = "[\\?&]" + name + "=([^&#]*)";
      var regex   = new RegExp(regexS);
      var results = regex.exec(location.search);
      if ( results === null )
      {
        return undefined;
      }
      else
      {
        var value = decodeURIComponent(results[1].replace(/\+/g, " "));
        if ( splitstr === undefined )
        {
          if ( type === undefined || type === 'f' ) value = eval(value);
        }
        else
        {
          value = value.split(splitstr)
          // <http://stackoverflow.com/a/4291498>
          if ( type === undefined || type === 'f' ) value = value.map(function(x){return parseFloat(x)});
        }
        return value;
      }
    }



    // setZeroTimeout <http://dbaron.org/log/20100309-faster-timeouts>
    (

      // add only to the window object, and hide everything else in a closure.

      function()
      {

        var timeouts = [];
        var messageName = "zero-timeout-message";

        // Like setTimeout, but only takes a function argument. There's no time argument
        // (always zero) and no arguments (you have to use a closure).
        function setZeroTimeout(fn)
        {
          timeouts.push(fn);
          window.postMessage(messageName, "*");
        }

        function handleMessage(event)
        {
          if (event.source == window && event.data == messageName)
          {
            event.stopPropagation();
            if (timeouts.length > 0)
            {
              var fn = timeouts.shift();
              fn();
            }
          }
        }

        window.addEventListener("message", handleMessage, true);

        // Add the one thing we want added to the window object.
        window.setZeroTimeout = setZeroTimeout;

      }

    )();



  </script>
  <style>
    body   { margin: 0; background: black }
    canvas { margin: auto; display: block }
  </style>
</head>
<body><canvas id="plano"></canvas></body>
</html>
